<?php
/*SCRIPT PER VERIFICARE LA DISPONIBILITA' DI CAMERE SU KWHOTEL
 * Attivazione con richiesta AJAX, riceve dati pacchetto e verifica disponibilità camere in base al numero di occupanti
 * Restituisce gli importi per 
 * ADULTI
 * BAMBINI
 * sulla base del biglietto scelto e delle notti
 * Le colazioni invece verranno gestite direttamente dal client come il totale
 */
date_default_timezone_set("Europe/Rome");

$dbhost='10.0.0.2'; 
$dbusername='root';
$dbuserpass='Ste589157';
$dbname = 'kwhotel';

// Connessione Database
$link = mysqli_connect($dbhost, $dbusername, $dbuserpass, $dbname) or die("Errore connessione Database " . mysqli_error($link));

//Recupero dati prenotazione

/*
//Dati di TEST
$checkin = '29/08/2019';
$checkout = '30/08/2019';
$adulti = '4';
$bamb412 = '0';
$bamb03 = '0';
$notti = "1";
$tipoBiglietto = "base";
*/

//Riceve campi GET
$checkin = filter_input(INPUT_GET, 'checkin', FILTER_SANITIZE_STRING);
$checkout = filter_input(INPUT_GET, 'checkout', FILTER_SANITIZE_STRING);
$adulti = filter_input(INPUT_GET, 'adulti', FILTER_SANITIZE_STRING);
$bamb412 = filter_input(INPUT_GET, 'bamb412', FILTER_SANITIZE_STRING);
$bamb03 = filter_input(INPUT_GET, 'bamb03', FILTER_SANITIZE_STRING);
$notti = filter_input(INPUT_GET, 'notti', FILTER_SANITIZE_STRING);
$tipoBiglietto = filter_input(INPUT_GET, 'tipoBiglietto', FILTER_SANITIZE_STRING);
$os = filter_input(INPUT_GET, 'os', FILTER_SANITIZE_STRING);



//Verifica validità data checkin
$data = explode("/", $checkin);
/*
if (!checkdate($data[1], $data[0], $data[2])) {  //Verifica se data valida
    $errore = "ERRORE CHECK DATA CHECKIN";
    echo 'ERRORE';
    require 'invioEmailErrore.php';
    exit();
}
 
 */
$checkinSTND = $data[2]."-".$data[1]."-".$data[0];


//Verifica validità data checkout
$data = explode("/", $checkout);
/*
if (!checkdate($data[1], $data[0], $data[2])) {  
    $errore = 'ERRORE CHECK DATA CHECKOUT';
    echo 'ERRORE';
    require 'invioEmailErrore.php';
    exit();
}
*/


$checkoutSTND = $data[2]."-".$data[1]."-".$data[0];

$dtarrivo = new DateTime($checkinSTND); 
$dtpartenza = new DateTime($checkoutSTND); 

//Verifica coerenza date con numero di notti
if ($dtpartenza->diff($dtarrivo)->days != $notti){
    $errore = "Differenza date non coerente con numero notti";
    echo 'ERRORE';
    require 'invioEmailErrore.php';
    exit();
}  


//Recupera il prezzo del Biglietto

$query = "SELECT prezzoAdulto, prezzoBamb FROM acquarioBiglietti WHERE tipoBiglietto = '$tipoBiglietto'";
$result = $link->query($query);
$biglietto = $result->fetch_assoc();
if ($result->num_rows < 1) {
    $errore = "Tipo Biglietto non trovato";
    echo 'ERRORE';
    require 'invioEmailErrore.php';
    exit();    
}

//Recupera le camere in base agli occupanti e le memorizza in array 'camere[] con la restrizione come indice'

$ABb = $adulti.$bamb412.$bamb03;   //Crea stringa per selezione  componenti della camera
$query = "SELECT restrizione, camere FROM acquarioCamere WHERE ospiti = $ABb ";
$result = $link->query($query);
if ($result->num_rows < 1) { //Troppi occupanti
    $risposta='TROPPI';
    echo "TROPPI";
    exit();
}
$camere = [];
while ($row = mysqli_fetch_assoc($result)) {
    $camere[$row['restrizione']] = $row['camere'];
}

//Inizializza variabili per controllo notti
$importoPacchetto = $importoAdulti = $importoBamb412 = $importoBamb03 = $importoNotte = $supp412 = $supp03 = $suppSabato = 0;
$dtNotte = $dtarrivo;


                        //Ciclo verifica disponibiltà e calcolo costo per ciascuna notte

$risposta = "";
$chiusa = 0;

for ($y = 0; $y < $notti; $y++) {
    
    $restrizione = 0;   //Setta restrizione base
    
//Crea data stringa per query
    $dataNotte = $dtNotte->format('Y-m-d');


//Recupera prezzo del mese e maggiorazione dei sabati relativi alla data in elaborazione
    $mese = $dtNotte->format('m');
    $query = "SELECT prezzo, suppSabato, supp412, supp03 FROM acqcuarioPrezziMese WHERE mese = '$mese' ";
    $result = $link->query($query);
    if ($result->num_rows < 1) {
        $errore = "Prezzi del mese non trovati";
        echo 'ERRORE';
        require 'invioEmailErrore.php';
        exit();    
    }
    $row = $result->fetch_assoc();
    $suppSabato = $row["suppSabato"];
    $importoNotte = $row["prezzo"];
    $supp412 = $row["supp412"];
    $supp03 = $row["supp03"];



//Verifica se Sabato, aggiunge restrizione e aumento prezzo 
    $giornoSettimana = $dtNotte->format('N');
    if ($giornoSettimana ==="6") {
        $importoNotte += $suppSabato;
        $restrizione = 2;
        //Se più di 1 notte riduce la restrizione a 1 e fa sconto di 2,5€ x notte
        if ($notti >1) $restrizione = 1;
    }
        
//Verifica se giorno particolare (se esiste) e sostituisce restrizioni e importi standard
    $query = "SELECT restrizione, importoNotte, supp412, supp03 FROM acquarioGiorniParticolari WHERE data = '$dataNotte'";
    $result = $link->query($query);
    if ($result->num_rows > 1) {
        $errore = "Rilevato doppione giorno particolare";
        echo 'ERRORE';
        require 'invioEmailErrore.php';
        exit();    
    }
    if ($result->num_rows > 0) {
	$row = $result->fetch_assoc();
        if($row["importoNotte"] == 0){ //Importo a 0 chiude la camera
            $chiusa = 1;
            $restrizione = 2;
        } else{
            $restrizione = $row["restrizione"];
            $importoNotte = $row["importoNotte"];
            if ($row["supp412"] != 0) $supp412 = $row["supp412"];
            if ($row["supp03"] != 0) $supp03 = $row["supp03"];
        }
    }
    
//Recupera camere occupate prenotazioni esistenti per la notte elaborata
    $query = "SELECT Pokoje.Symbol "
            . "FROM Rezerwacje LEFT JOIN Pokoje ON Pokoje.PokojID = Rezerwacje.PokojID "
            . "WHERE DataOd <= '$dataNotte' AND DataDo >= '$dataNotte'";
    $result = $link->query($query);

//Inserisce tutti i numeri di camera occupati nell'array
    $occupate = array();
    $index = 0;
    while ($row = mysqli_fetch_assoc($result)) {
        $occupate[$index] = $row['Symbol'];
        $index ++;
    }

//Verifica disponibilità per la notte elaborata

    $cameraRicercata = explode(",", $camere[$restrizione]);

//Ciclo per verifica camera disponibile a partire dall'inizio delle camere possibili
    $lungh = count($cameraRicercata);
    $trovato = 0;
    for ($x = 0; $x < $lungh; $x++) {
        //Cerca valore all'interno dell'array delle camere occupate, se trova una camera non occupata interrompe
        // il ciclo, altrimenti termina il ciclo e risponde NO
        if (!in_array((string) $cameraRicercata[$x], $occupate)){
            $trovato = 1;
            break;
        }
    }
//Verifica se dal ciclo di verifica è stata trovata una camera non occupata
    if (!$trovato) $risposta = 'NO';
    else if ($risposta === "") $risposta = "OK"; 
    
	
//Somma importo della notte a totale pacchetto
    $importoAdulti += ($importoNotte / 2) * $adulti;
    $importoBamb412 += $bamb412 * $supp412;
    $importoBamb03 += $bamb03 * $supp03;

/***************************************************************************************************************** */
//Verifica se LUGLIO e GalataAcquario e sottrae importo biglietti bambini
if ($mese == 7 && $tipoBiglietto == "galataAcquario"){
    //$importoBamb412 = $importoBamb412 - ($bamb412 * 31);
    $biglietto['prezzoBamb'] = 0;
}
/********************************************************************************************************************* */
//Aggiorna le variabili e ricomincia il ciclo
    $importoNotte = 0;
    $dtNotte->modify("+1 day");
}


//Se più di 1 Notte sconto 5€ x notte
if ($notti > 1) $importoAdulti = $importoAdulti - (5 * (int)$notti);

//Aggiunge importi costo biglietti
$importoAdulti += $adulti * $biglietto['prezzoAdulto'];
if ($mese == 7 && $tipoBiglietto == "galataAcquario"){
    $importoBamb412 += $bamb412;
}
else $importoBamb412 += $bamb412 * $biglietto['prezzoBamb'];

//Imposta a NO se $chiusa = 1
if ($chiusa === 1) $risposta = 'NO';

echo "$risposta,$importoAdulti,$importoBamb412,$importoBamb03";

//Inserisce richiesta nello storico
$query = "INSERT INTO acquarioStorico (posto, ip, checkin, checkout, notti, biglietto, adulti, bamb412, bamb03) "
        . "VALUES ('$risposta', '$_SERVER[REMOTE_ADDR]', '$checkin', '$checkout', '$notti', '$tipoBiglietto',"
        . " '$adulti', '$bamb412', '$bamb03') ";
$result = $link->query($query);
