<?php

/*SCRIPT PER VERIFICARE LA DISPONIBILITA' DI CAMERE SU KWHOTEL
 * Attivazione con richiesta AJAX, riceve dati pacchetto e verifica disponibilità camere in base al numero di occupanti
 * Restituisce JSON con importi per 
 * ADULTI
 * BAMBINI
 * PREZZI DI TUTTI I BIGLIETTI
 * sulla base del biglietto scelto e delle notti
 * Le colazioni invece verranno gestite direttamente dal client come il totale
 */
date_default_timezone_set("Europe/Rome");

$dbhost='10.0.0.2';
$dbusername='root';
$dbuserpass='Ste589157';
$dbname = 'kwhotel';

// Connessione Database
$link = mysqli_connect($dbhost, $dbusername, $dbuserpass, $dbname) or die("Errore connessione Database " . mysqli_error($link));

$risposta = new stdClass();

//Recupero dati prenotazione

/*
//Dati di TEST
$checkin = '29/08/2020';
$checkout = '30/08/2020';
$adulti = '2';
$notti = "1";
$bamb0 = '7';
//$bamb1 = '4';
//$bamb2 = '7';
//$bamb3 = '5';
$acquarioLunch = 0;
$galata = 0;
$lanterna = 0;
$riscio = 0;
$gitaBarca = 0;
$whale = 0;
$park = 0;
$bonus = '300';
*/


//Riceve campi GET
$checkin = filter_input(INPUT_GET, 'checkin', FILTER_SANITIZE_STRING);
$checkout = filter_input(INPUT_GET, 'checkout', FILTER_SANITIZE_STRING);
$adulti = intval(filter_input(INPUT_GET, 'adulti', FILTER_SANITIZE_STRING));
$notti = intval(filter_input(INPUT_GET, 'notti', FILTER_SANITIZE_STRING));
//Se non presenti bambini le variabili non saranno settate
$bamb0 = filter_input(INPUT_GET, 'bamb0', FILTER_SANITIZE_STRING);
$bamb1 = filter_input(INPUT_GET, 'bamb1', FILTER_SANITIZE_STRING);
$bamb2 = filter_input(INPUT_GET, 'bamb2', FILTER_SANITIZE_STRING);
$bamb3 = filter_input(INPUT_GET, 'bamb3', FILTER_SANITIZE_STRING);
$bamb4 = filter_input(INPUT_GET, 'bamb4', FILTER_SANITIZE_STRING);
$bonus = filter_input(INPUT_GET, 'bonus', FILTER_SANITIZE_STRING);
$os = filter_input(INPUT_GET, 'os', FILTER_SANITIZE_STRING);


//Verifica validità date
$data = explode("/", $checkin);
$checkinSTND = $data[2]."-".$data[1]."-".$data[0];
$dtarrivo = new DateTime($checkinSTND); 

$data = explode("/", $checkout);
$checkoutSTND = $data[2]."-".$data[1]."-".$data[0];
$dtpartenza = new DateTime($checkoutSTND); 

//Verifica coerenza date con numero di notti
if ($dtpartenza->diff($dtarrivo)->days != $notti){
    $errore = "Differenza date non coerente con numero notti";
    $risposta->stato = "ERRORE";
    echo json_encode($risposta);
    require 'invioEmailErrore.php';
    exit();
}

//Recupera i prezzi dei Biglietti
$mese = (int)date('m', strtotime($checkinSTND));
$query = "SELECT * FROM _biglietti WHERE id = $mese";
$result = $link->query($query);
$biglietti = $result->fetch_assoc();
if ($result->num_rows < 1) {
    $errore = "Lettura biglietti fallita";
    $risposta->stato = "ERRORE";
    echo json_encode($risposta);
    require 'invioEmailErrore.php';
    exit();    
}

//Recupera le camere in base agli occupanti e le memorizza in array 'camere[] con la restrizione come indice'

//Suddivide i bambini in gruppi in base all'età
$bamb412 = 0;
$bamb03 = 0;
if (isset($bamb0)){ 
    if (intval($bamb0) < 4) $bamb03 ++;
    if (intval($bamb0) > 3 && intval($bamb0) < 13) $bamb412 ++;
    if (intval($bamb0) > 12) $adulti ++;
}
if (isset($bamb1)){ 
    if (intval($bamb1) < 4) $bamb03 ++;
    if (intval($bamb1) > 3 && intval($bamb1) < 13) $bamb412 ++;
    if (intval($bamb1) > 12) $adulti ++;
}
if (isset($bamb2)){ 
    if (intval($bamb2) < 4) $bamb03 ++;
    if (intval($bamb2) > 3 && intval($bamb2) < 13) $bamb412 ++;
    if (intval($bamb2) > 12) $adulti ++;
}
if (isset($bamb3)){ 
    if (intval($bamb3) < 4) $bamb03 ++;
    if (intval($bamb3) > 3 && intval($bamb3) < 13) $bamb412 ++;
    if (intval($bamb3) > 12) $adulti ++;
}
if (isset($bamb4)){ 
    if (intval($bamb4) < 4) $bamb03 ++;
    if (intval($bamb4) > 3 && intval($bamb4) < 13) $bamb412 ++;
    if (intval($bamb4) > 12) $adulti ++;
}



$ABb = $adulti.$bamb412.$bamb03;   //Crea stringa per selezione  componenti della camera
$query = "SELECT restrizione, camere FROM acquarioCamere WHERE ospiti = $ABb ";
$result = $link->query($query);
if ($result->num_rows < 1) {        //Troppi occupanti
    $risposta->stato = "TROPPI";
    echo json_encode($risposta);
    exit();
}
$camere = []; //Array contenente camere disponibili in base alla restrizione 1,2,3
while ($row = mysqli_fetch_assoc($result)) {
    $camere[$row['restrizione']] = $row['camere'];
}

//Inizializza variabili per controllo notti
$importoPacchetto = $importoAdulti = $importoBamb412 = $importoBamb03 = $importoNotte = $supp412 = $supp03 = $suppSabato = 0;
$dtNotte = $dtarrivo;

                        //Ciclo verifica disponibiltà e calcolo costo per ciascuna notte


$chiusa = 0;
$risposta->stato = "OK";

/************************************* RECUPERA I PREZZI DELLA/E NOTTI ADULTI E BAMBINI  ************************************************************/

for ($y = 0; $y < $notti; $y++) {
    
    $restrizione = 0;   //Setta restrizione base
    
//Crea data stringa per query
    $dataNotte = $dtNotte->format('Y-m-d'); 

//Recupera prezzo del mese e supplementi
    $mese = $dtNotte->format('m');
    $query = "SELECT prezzo, suppSabato, supp412, supp03 FROM acqcuarioPrezziMese WHERE mese = '$mese' ";
    $result = $link->query($query);
    if ($result->num_rows < 1) {
        $errore = "Prezzi del mese non trovati";
        $risposta->stato = "ERRORE";
        echo json_encode($risposta);
        require 'invioEmailErrore.php';
        exit();    
    }
    $row = $result->fetch_assoc();
    $suppSabato = $row["suppSabato"];
    $importoNotte = $row["prezzo"];
    $supp412 = $row["supp412"];
    $supp03 = $row["supp03"];

//Verifica se Sabato, aggiunge restrizione e aumento prezzo 
    $giornoSettimana = $dtNotte->format('N');
    if ($giornoSettimana ==="6") {
        $importoNotte += $suppSabato;
        $restrizione = 2;
        //Se più di 1 notte riduce la restrizione a 1 
        if ($notti >1) $restrizione = 1;
    }

//Override $sempreaperta = 1, in caso sia 0 applica policy normale
    $sempreAperta = 1;

    //Verifica se giorno particolare (se esiste) e sostituisce restrizioni e importi standard
    $query = "SELECT sempreAperta, minStay, restrizione, importoNotte, supp412, supp03 FROM acquarioGiorniParticolari WHERE data = '$dataNotte'";
    $result = $link->query($query);
    if ($result->num_rows > 1) {
        $errore = "Rilevato doppione giorno particolare";
        $risposta->stato = "ERRORE";
        echo json_encode($risposta);
        require 'invioEmailErrore.php';
        exit();    
    }
    if ($result->num_rows > 0) {
        
        $row = $result->fetch_assoc();

        //Verifica se giorno particolare prevede policy normale
        if ($row["sempreAperta"] === "0") $sempreAperta = 0;

        if($row["minStay"] > $notti){ //Controlla minStay 
            $chiusa = 1;
            $restrizione = 2;
        } 
        if($row["importoNotte"] == 0){ //Importo a 0 chiude la camera
            $chiusa = 1;
            $restrizione = 2;
            $sempreAperta = 0; //Chiude camera comunque se importonotte = 0
        } else{
            $restrizione = $row["restrizione"];
            $importoNotte = $row["importoNotte"];
            if ($row["supp412"] != 0) $supp412 = $row["supp412"];
            if ($row["supp03"] != 0) $supp03 = $row["supp03"];
        }
        
    }

/**************************************************CONTROLLO CAMERE DISPONIBILI SU KWHOTEL ******************************************************/

if (!$sempreAperta){

    //Recupera camere occupate prenotazioni esistenti per la notte elaborata
        $query = "SELECT Pokoje.Symbol "
                . "FROM Rezerwacje LEFT JOIN Pokoje ON Pokoje.PokojID = Rezerwacje.PokojID "
                . "WHERE DataOd <= '$dataNotte' AND DataDo >= '$dataNotte'";
        $result = $link->query($query);

    //Inserisce tutti i numeri di camera occupati nell'array
        $occupate = array();
        $index = 0;
        while ($row = mysqli_fetch_assoc($result)) {
            $occupate[$index] = $row['Symbol'];
            $index ++;
        }

    //Verifica disponibilità per la notte elaborata

        $cameraRicercata = explode(",", $camere[$restrizione]);

    //Ciclo per verifica camera disponibile a partire dall'inizio delle camere possibili
        $lungh = count($cameraRicercata);
        $trovato = 0;
        for ($x = 0; $x < $lungh; $x++) {
            //Cerca valore all'interno dell'array delle camere occupate, se trova una camera non occupata interrompe
            // il ciclo, altrimenti termina il ciclo e risponde NO
            if (!in_array((string) $cameraRicercata[$x], $occupate)){
                $trovato = 1;
                break;
            }
        }
    //Verifica se dal ciclo di verifica è stata trovata una camera non occupata
        if (!$trovato) $risposta->stato = 'NO';

    //Imposta a NO se $chiusa = 1
        if ($chiusa === 1) $risposta->stato = 'NO';
}


/**************************************************************************************************************************************************
***************************************************************************************************************************************************/    

/*****************************************************CALCOLO IMPORTI *****************************************************************************/

//Somma importo della notte a totale pacchetto

    if ($adulti == 1){  //Lascia invariato il costo della notte x 2 Adulti ma se presenti, calcola importo bambini ridootto di 1
        $importoAdulti += $importoNotte;
        if ($bamb412 > 0) {
            $importoBamb412 += ($bamb412 - 1) * $supp412;
            $importoBamb03 += $bamb03 * $supp03;
        } else {
            $importoBamb412 = 0;
            if ($bamb03 > 0) $importoBamb03 += ($bamb03 - 1) * $supp03;
            else $importoBamb03 = 0;
        }
    } else {
        $importoAdulti += ($importoNotte / 2) * $adulti;
        $importoBamb412 += $bamb412 * $supp412;
        $importoBamb03 += $bamb03 * $supp03;
    }

/********************************************************************************************************************* */
//Aggiorna le variabili e ricomincia il ciclo
    $importoNotte = 0;
    $dtNotte->modify("+1 day");
}

/****************************************** CALCOLO PREZZI BIGLIETTI ****************************************************/

//Pasti Vegia Zena
$risposta->vegiaZena = $adulti * $biglietti['VegiaZena'] + $bamb412 * $biglietti['VegiaZenaBamb'];

//Pasti SOHO
$risposta->soho = $adulti * $biglietti['Soho'] + $bamb412 * $biglietti['SohoBamb'];

//Pernottamento e Biglietto Acquario
$risposta->prezzoAdulti = $importoAdulti + ($adulti * $biglietti['Acquario']);
$risposta->prezzoBamb = $importoBamb412 + $importoBamb03 + ($bamb412 * $biglietti['AcquarioBamb']);

//Acquario Lunch
$risposta->acquarioLunch = $adulti * ($biglietti['AcquarioLunch'] - $biglietti['Acquario']) + $bamb412 * ($biglietti['AcquarioLunchBamb'] - $biglietti['AcquarioBamb']);

//GalataAcquario (supplemento rispetto Biglietto base Acquario)
$risposta->galata = $adulti * ((int)$biglietti['GalataAcquario'] - (int)$biglietti['Acquario']); + $bamb412 * ((int)$biglietti['GalataAcquarioBamb'] - (int)$biglietti['AcquarioBamb']); 

//Pianeta (Supplemento rispetto ad Acquario)
$risposta->pianeta = $adulti * ((int)$biglietti['Pianeta'] - (int)$biglietti['Acquario']); + $bamb412 * ((int)$biglietti['PianetaBamb'] - (int)$biglietti['AcquarioBamb']); 

//Lanterna gratuito fino a 6 anni
$interi = $adulti;
$bamb06 = 0;
if (isset($bamb0)) (int)$bamb0 < 7? $bamb06 ++ : $interi ++;
if (isset($bamb1)) (int)$bamb1 < 7? $bamb06 ++ : $interi ++;
if (isset($bamb2)) (int)$bamb2 < 7? $bamb06 ++ : $interi ++;
if (isset($bamb3)) (int)$bamb3 < 7? $bamb06 ++ : $interi ++;
if (isset($bamb4)) (int)$bamb4 < 7? $bamb06 ++ : $interi ++;

$risposta->lanterna = $interi * $biglietti['Lanterna'];

//Risciò 45€ prezzo unico x 2 Adulti e 2 bamb06 gratuiti (non tiene conto del numero dei bambini < 6 anni)
$risposta->riscio = ceil($interi / 2) * $biglietti['Riscio'];

//Genova dal Mare bamb04 gratuiti, bamb514 ridotto
$interi = $adulti;
$bamb04 = 0;
$bamb514 = 0;
if (isset($bamb0)) (int)$bamb0 < 5? $bamb04 ++ : ((int)$bamb0 < 15? $bamb514 ++ : $interi ++);
if (isset($bamb1)) (int)$bamb1 < 5? $bamb04 ++ : ((int)$bamb1 < 15? $bamb514 ++ : $interi ++);
if (isset($bamb2)) (int)$bamb2 < 5? $bamb04 ++ : ((int)$bamb2 < 15? $bamb514 ++ : $interi ++);
if (isset($bamb3)) (int)$bamb3 < 5? $bamb04 ++ : ((int)$bamb3 < 15? $bamb514 ++ : $interi ++);
if (isset($bamb4)) (int)$bamb4 < 5? $bamb04 ++ : ((int)$bamb4 < 15? $bamb514 ++ : $interi ++);

$risposta->gitaBarca = $interi * $biglietti['GitaBarca'] + $bamb514 * $biglietti['GitaBarcaBamb'];

//Whale
$risposta->whale = $interi * $biglietti['Whale'] + $bamb514 * $biglietti['WhaleBamb'];

//2 Golfi intero 
$risposta->golfiIntero = $interi * $biglietti['GolfiIntero'] + $bamb514 * $biglietti['GolfiInteroBamb'];

//2 Golfi mezza giornata 
$risposta->golfiMezzo = $interi * $biglietti['GolfiMezzo'] + $bamb514 * $biglietti['GolfiMezzoBamb'];

//5 Terre
$risposta->cinqueTerre = $interi * $biglietti['CinqueTerre'] + $bamb514 * $biglietti['CinqueTerreBamb'];

//Park
$risposta->park = (int)$biglietti['Park'] * $notti;

//Bonus
$risposta->bonus = $biglietti['Bonus'];

//Colazione
$risposta->colazione = ($adulti * (float)$biglietti['Colazione'] + $bamb412 * (float)$biglietti['ColazioneBamb']) * $notti; 

echo json_encode($risposta);

//Inserisce richiesta nello storico
$query = "INSERT INTO acquarioStorico (posto, ip, checkin, checkout, notti, biglietto, adulti, bamb412, bamb03) "
        . "VALUES ('$risposta->stato', '$_SERVER[REMOTE_ADDR]', '$checkin', '$checkout', '$notti', '$tipoBiglietto',"
        . " '$adulti', '$bamb412', '$bamb03') ";
$result = $link->query($query);
