<?php
//Predisposizione PHPMailer
$dir = "../app/";
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;
require $dir . 'mail/PHPMailer/src/Exception.php';
require $dir . 'mail/PHPMailer/src/PHPMailer.php';
require $dir . 'mail/PHPMailer/src/SMTP.php';

$emailFrom = "sito@hotelgallesgenova.com";
$emailHotel = "info@hotelgallesgenova.com";

$in = filter_input(INPUT_POST, 'in', FILTER_SANITIZE_STRING);
$out = filter_input(INPUT_POST, 'out', FILTER_SANITIZE_STRING);
$adulti = filter_input(INPUT_POST, 'adulti', FILTER_SANITIZE_STRING);
$bamb412 = filter_input(INPUT_POST, 'bamb412', FILTER_SANITIZE_STRING);
$bamb03 = filter_input(INPUT_POST, 'bamb03', FILTER_SANITIZE_STRING);
$nome = filter_input(INPUT_POST, 'nome', FILTER_SANITIZE_STRING);
$telefono = filter_input(INPUT_POST, 'telefono', FILTER_SANITIZE_STRING);
$emailCliente = filter_input(INPUT_POST, 'email', FILTER_SANITIZE_STRING);
$messaggio = filter_input(INPUT_POST, 'messaggio', FILTER_SANITIZE_STRING);

//Controllo reChapcha
$recaptcha_url = 'https://www.google.com/recaptcha/api/siteverify';      
$recaptcha_secret = '6Lc7fd0UAAAAAOj8F85iAqW_pTy5obem8FEHTIAs';      
$recaptcha_response = $_POST['recaptcha_response'];        
// Istanziare e decidoficare la richiesta POST:      
$recaptcha = file_get_contents($recaptcha_url . '?secret=' . $recaptcha_secret . '&response=' . $recaptcha_response);      
$recaptcha = json_decode($recaptcha);        
// Azioni da compiere basate sul punteggio ottenuto:      
if ($recaptcha->score < 0.5) {  
   echo 'Errore';   
   exit;
}    

//Invio email a Hotel
$oggetto = "Richiesta Informazioni check-in:$in - checkout:$out - Sig. $nome";
$body = "E' stata effettuata la seguente richiesta:<br><br><br>";
$body .= "N. Adulti: $adulti<br>";
$body .= "N. Bambini 4-12 anni: $bamb412<br>";
$body .= "N. Bambini 0-3 anni: $bamb03<br><br>";
$body .= "Informazioni di Contatto:<br><br>";
$body .= "Telefono: $telefono<br>";
$body .= "Email: $emailCliente<br><br>";
$body .= "Messaggio:\n\n $messaggio<br>";

$mail = new PHPMailer(true);                              // Passing `true` enables exceptions
try {
    include $dir . 'configMail.php';
    //Recipients
    $mail->setFrom($emailFrom, 'Sito'); //Mittente
    $mail->addAddress($emailHotel);     // Destinatario
    $mail->addReplyTo($emailCliente, 'Informazioni'); //Risposta email Cliente
    $mail->Subject = $oggetto;
    $mail->Body = $body;
    $mail->AltBody = 'ALT Body';
    $mail->send();

} catch (Exception $e) {
    echo 'ERRORE';
    $errore = $mail->ErrorInfo;
    require 'invioEmailErrorePrenotazione.php';
    exit;
}

//Invio email al cliente di confema
$oggetto = "Abbiamo ricevuto la vostra richiesta.";
$body = "Vi ringraziamo per la consultazione.<br>";
$body .= "La vostra richiesta verrà elaborata appena possibile.<br><br>";
$body .= "Per qualunque ulteriore informazione siamo a disposizione:<br><br>";
$body .= "Telefono: (+39) 010 2462820<br><br>";
$body .= "www.hotelgallesgenova.com<br><br>";
$body .= "Cordiali saluti<br><br>";
$body .= "Lo staff dell'Hotel Galles<br>";

$mail = new PHPMailer(true);                              // Passing `true` enables exceptions
try {
    include $dir . 'configMail.php';
    //Recipients
    $mail->setFrom($emailHotel, 'Hotel Galles'); //Mittente
    $mail->addAddress($emailCliente);     // Destinatario
    $mail->addReplyTo($emailHotel, 'Informazioni'); //Risposta email Cliente
    $mail->Subject = $oggetto;
    $mail->Body = $body;
    $mail->AltBody = 'ALT Body';
    $mail->send();
    echo "OK";

} catch (Exception $e) {
    echo 'ERRORE';
    $errore = $mail->ErrorInfo;
    require 'invioEmailErrorePrenotazione.php';
    exit;
}
     